package com.dgtis.dorm.manager.db.dao;

import com.dgtis.dorm.manager.db.domain.AdministrativeItemsDoc;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 *  办理事项相关文档
 *
 * @version 1.0
 * @since JDK1.8
 * @author huanghaoqi
 * @date 2018年12月03日 15:27:42
 */
public interface AdministrativeItemsDocMapper {

    /**
     * 方法描述  根据事项ID查询
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:09:14
     */
    List<AdministrativeItemsDoc> selectByItemsId(@Param("itemsId") Integer itemsId,@Param("type") Integer type);

    /**
     * 方法描述  批量添加
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:09:14
     */
    void insertBatch(@Param("itemsDocs") List<AdministrativeItemsDoc> administrativeItemsDocs);

    /**
     * 方法描述  根据事项ID删除
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:14:13
     */
    void deleteByItemsId(@Param("itemsId") Integer itemsId);

    /**
     * 方法描述  根据事项ID集合批量删除
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:14:13
     */
    void deleteByItemsIds(@Param("itemsIds") List<Integer> itemsIds);
}