package com.dgtis.dorm.manager.db.dao;

import com.dgtis.dorm.manager.db.domain.AdministrativeItems;
import com.dgtis.dorm.manager.db.param.ItemsQueryParam;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 *  办理事项
 *
 * @version 1.0
 * @since JDK1.8
 * @author huanghaoqi
 * @date 2018年12月03日 15:27:42
 */
public interface AdministrativeItemsMapper {

    /**
     * 方法描述  查询列表
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:09:14
     */
    List<AdministrativeItems> selectList(ItemsQueryParam param);

    /**
     * 方法描述  查询总数
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:09:14
     */
    Long count(ItemsQueryParam param);

    /**
     * 方法描述  根据ID查询
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:14:13
     */
    AdministrativeItems selectByPrimaryKey(@Param("id") Integer id);

    /**
     * 方法描述  添加
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:12:37
     */
    void insert(AdministrativeItems administrativeItems);

    /**
     * 方法描述  修改
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:12:37
     */
    void update(AdministrativeItems administrativeItems);
    /**
     * 方法描述  批量删除
     * @param ids id集合
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:47:17
     */
    void deleteByIds(@Param("ids") List<Integer> ids);

    /**
     * 方法描述  根据ID集合查询
     *
     * @author huanghaoqi
     * @date 2018年12月03日 15:14:13
     */
    List<AdministrativeItems> selectByIds(@Param("ids") List<Integer> ids);

    /**
     * 方法描述  根据一级name+二级name查询二维码图片
     * @param oneTitlePY
     * @param twoTitlePY
     * @return
     */
    List<String> selectQrcodeStorageUrlByNames(@Param("oneTitlePY") String oneTitlePY,
                                               @Param("twoTitlePY") String twoTitlePY);
}